/*
 *	G E T H D R . C
 *
 *	Part of the MDQS
 *
 *	Doug Kingston, BRL
 */
#include <stdio.h>
#include "queue.h"
#include "rawreq.h"

extern char *index();

/*
 *	G E T H D R
 *
 *	Get the request structure from the file specified
 *	and convert to internal form.
 */
struct request *
gethdr (fp, rp)
FILE	*fp;
register struct request *rp;
{
	extern  long atol();
	struct	rawrequest raw;
	register struct  rawrequest *rwp = &raw;
	register char *cp;

	fseek (fp, 0L, 0);		/* Go to the start of the file */
	if(fread (&raw, sizeof raw, 1, fp) != 1)
		return (NULL);
	
	rwp->rw_name[QDIRSIZ] = 0;
	if (cp = index (rwp->rw_name, ' '))
		*cp = 0;
	strncpy (rp->r_name, rwp->rw_name, QDIRSIZ);
	rwp->rw_que[QUESIZ] = 0;
	if (cp = index (rwp->rw_que, ' '))
		*cp = 0;
	strncpy (rp->r_que, rwp->rw_que, QUESIZ);
	rp->r_pri = atoi (rwp->rw_pri);
	rp->r_status = atoi (rwp->rw_status);
	rp->r_uid = atoi (rwp->rw_uid);
	rp->r_gid = atoi (rwp->rw_gid);
	rwp->rw_forms[FORMSIZ] = 0;
	if (cp = index (rwp->rw_forms, ' '))
		*cp = 0;
	strncpy (rp->r_forms, rwp->rw_forms, FORMSIZ);
	rp->r_options = atoi (rwp->rw_options);
	rp->r_copies = atoi (rwp->rw_copies);
	rp->r_size = atol (rwp->rw_size);
	rp->r_tstart = atol (rwp->rw_tstart);
	rp->r_tsubmit = atol (rwp->rw_tsubmit);
	rp->r_tdelay = 0L;
	rp->r_nextreq = (struct request *) NULL;
	return (rp);
}
