/*
 *		G E T W D . C
 *
 *	Get the working directory.  (emulation of 4.2BSD syscall)
 */
#include <stdio.h>
#include "queue.h"

extern FILE *popen();
extern char *index();

char *
getwd(dest)
char	*dest;
{
	FILE	*pf;
	register char	*cp;

	/*
	 *	Grab the current directory (if you can...)
	 */
	if(( pf = popen("pwd", "r")) == NULL  ||
	   fgets( dest, PATHSIZ, pf ) == NULL ) {
		strcpy( dest, "Cannot get working directory" );
	   	if (pf)
			pclose(pf);
	   	return(0);
	}
	pclose( pf );

	cp = index(dest, '\n');
	if( cp != NULL )
		*cp = 0;
	return(cp);
}
