#include "queue.h"
#include <signal.h>

extern char *Queue2;

/*
 *		Q U E U E I T ( )
 *  Call our second half which will put this request in the actual
 *  queue area which is protected.
 */
queueit (rp, verbose)
struct request *rp;
int	verbose;
{
#ifdef OF_QUESTIONABLE_VALUE
	if( !verbose && fork() > 0 )
		exit( 0 );		/* Parent exits to free user */
#endif OF_QUESTIONABLE_VALUE

	signal (SIGHUP, SIG_IGN);
	rp->r_name[QDIRSIZ] = 0;	/* Paranoid. */
	if (verbose)
		execl( Queue2, "queue2", rp->r_name, "-v", 0);
	else
		execl( Queue2, "queue2", rp->r_name, 0 );
	bomb( "Exec of QUEUE2 failed.\n" );
}
